/* eslint no-console: 0 */
import { ApolloLink } from 'apollo-link'; // $FlowFixMe

import { print } from 'graphql/language';
import chalk from 'chalk';
export function DEFAULT_LOGGER(_ref) {
  var operationName = _ref.operationName,
      query = _ref.query,
      variables = _ref.variables;
  console.log(chalk.gray("\n==================== [apollo-link-log] START ==================\noperationName: " + (operationName || 'null') + "\n\n" + query + "\nvariables: " + JSON.stringify(variables, null, 2) + "\n==================== [apollo-link-log] END ====================\n    "));
}

var createLogLink = function createLogLink(_temp) {
  var _ref2 = _temp === void 0 ? {} : _temp,
      _ref2$logger = _ref2.logger,
      logger = _ref2$logger === void 0 ? DEFAULT_LOGGER : _ref2$logger,
      _ref2$enabled = _ref2.enabled,
      enabled = _ref2$enabled === void 0 ? true : _ref2$enabled;

  return new ApolloLink(function (operation, forward) {
    return forward(operation).map(function (result) {
      if (!enabled) return result;
      var operationName = operation.operationName,
          query = operation.query,
          variables = operation.variables;
      logger({
        operationName: operationName,
        query: print(query),
        variables: variables,
        operation: operation
      });
      return result;
    });
  });
};

export default createLogLink;