"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.DEFAULT_LOGGER = DEFAULT_LOGGER;
exports.default = void 0;

var _apolloLink = require("apollo-link");

var _language = require("graphql/language");

var _chalk = _interopRequireDefault(require("chalk"));

/* eslint no-console: 0 */
// $FlowFixMe
function DEFAULT_LOGGER(_ref) {
  var operationName = _ref.operationName,
      query = _ref.query,
      variables = _ref.variables;
  console.log(_chalk.default.gray("\n==================== [apollo-link-log] START ==================\noperationName: " + (operationName || 'null') + "\n\n" + query + "\nvariables: " + JSON.stringify(variables, null, 2) + "\n==================== [apollo-link-log] END ====================\n    "));
}

var createLogLink = function createLogLink(_temp) {
  var _ref2 = _temp === void 0 ? {} : _temp,
      _ref2$logger = _ref2.logger,
      logger = _ref2$logger === void 0 ? DEFAULT_LOGGER : _ref2$logger,
      _ref2$enabled = _ref2.enabled,
      enabled = _ref2$enabled === void 0 ? true : _ref2$enabled;

  return new _apolloLink.ApolloLink(function (operation, forward) {
    return forward(operation).map(function (result) {
      if (!enabled) return result;
      var operationName = operation.operationName,
          query = operation.query,
          variables = operation.variables;
      logger({
        operationName: operationName,
        query: (0, _language.print)(query),
        variables: variables,
        operation: operation
      });
      return result;
    });
  });
};

var _default = createLogLink;
exports.default = _default;